KLOGD(1)

NAME
klogd — kernel log daemon.

SYNOPSIS
klogd -c [n] -d -f [fname] -os

DESCRIPTION
klogd is a system daemon which intercepts and logs Linux kernel messages.

OPTIONS

-c  Sets the default log level of console messages to [n].

-d  Enable debugging mode. This will generate LOTS of output to stderr.

-f  Log messages to the specified filename rather than to the syslog facility.

-o  Execute in 'one-shot' mode. This causes klogd to read and log all the messages that are found in the kernel message buffers. After a single read and log cycle the daemon exits.

-s  Force klogd to use the system call interface to the kernel message buffers.

OVERVIEW
The functionality of klogd has been typically incorporated into other versions of syslogd but this seems to be a poor place for it. In the modern Linux kernel a number of kernel messaging issues such as sourcing and prioritization must be addressed. Incorporating kernel logging into a separate process would appear to offer a cleaner separation of services. In Linux there are two potential sources of kernel log information: the /proc filesystem and the syscall (sys_syslog) interface, although ultimately they are one and the same. Klogd is designed to choose whichever source of information is the most appropriate. It does this by first checking for the presence of a mounted /proc filesystem. If this is found the /proc/kmsg file is used as the source of kernel log information. If the proc filesystem is not mounted klogd uses a system call to obtain kernel messages. The command line switch (-s) can be used to force klogd to use the system call interface as its messaging source. If kernel messages are directed through the syslogd daemon the klogd daemon, as of version 1.1, has the ability to properly prioritize kernel messages. Prioritization of the kernel messages was added at approximately the pl13 level of the kernel. The raw kernel messages are of the form:

    <[0-7]>Something said by the kernel.

The priority of the kernel message is encoded as a single numeric digit enclosed inside the <> pair. The definitions of these values is given in the kernel include file kernel.h. When a message is received from the kernel the klogd daemon reads this priority level and assigns the appropriate priority level to the syslog message. If file output (-f) is used the prioritization sequence is left pre-pended to the kernel message. The klogd daemon also allows the ability to alter the presentation of kernel messages to the system console. Consequent with the prioritization of kernel messages was the inclusion of default messaging levels for the kernel. In a stock kernel the the default console log level is set to 7. Any messages with a priority level numerically lower than 7 (higher priority) appear on the console. Messages of priority level 7 are considered to be 'debug' messages and will thus not appear on the console. Many administrators, particularly in a multi-user environment, prefer that all kernel messages be handled by klogd and either directed to a file or to the syslogd daemon. This prevents 'nuisance' messages such as line printer out of paper or disk change detected from cluttering the console. By default the klogd daemon executes a system call to inhibit all kernel messages (except for panics) from being displayed on the console. The -c switch can be used to alter this behavior. The arguement given to the -c switch specifies the priority level of messages which will be directed to the console. Note that messages of a priority value LOWER than the indicated number will be directed to the console.

    For example, to have the kernel display all messages with a priority level of 3 (KERN_ERR) or more severe the following command would be executed:

    	klogd -c 4

The definitions of the numeric values for kernel messages are given in the file kernel.h which can be found in the /usr/include/linux directory if the kernel sources are installed. These values parallel the syslog priority values which are defined in the file syslog.h found in the /usr/include/sys sub-directory. The klogd daemon can also be used in a 'one-shot' mode for reading the kernel message buffers. One shot mode is selected by specifying the -o switch on the command line. Output will be directed to either the syslogd daemon or to an alternate file specified by the -f switch.

    For example, to read all the kernel messages after a system boot and record them in a file called krnl.msg the following command would be given.

    	klogd -o -f ./krnl.msg

SIGNAL HANDLING
The klogd daemon will respond to six signals: SIGHUP, SIGINT, SIGKILL, SIGTERM, SIGTSTP and SIGCONT. The SIGINT, SIGKILL, SIGTERM and SIGHUP signals will cause the daemon to close its kernel log sources and terminate gracefully. The SIGTSTP and SIGCONT singals are used to start and stop kernel logging. Upon receipt of a SIGTSTP signal the daemon will close its log sources and spin in an idle loop. Subsequent receipt of a SIGCONT signal will cause the daemon to go through its initialization sequence and rechoose an input source. Using SIGSTOP and SIGCONT in combination the kernel log input can be rechosen without stopping and restarting the daemon. For example if the /proc file system is to be un-mounted the following command sequence should be used:

# kill -TSTP pid
# umount /proc
# kill -CONT pid

Notations will be made in the system logs with LOG_INFO priority documenting the start/stop of logging.

FILES
/proc/kmsg

BUGS
Probably numerous. Well formed context diffs appreciated.

AUTHOR
Dr. Greg Wettstein (greg%wind.uucp@plains.nodak.edu)
Enjellic Systems Development

Oncology Research Divsion Computing Facility
Roger Maris Cancer Center
Fargo, ND 58122